package prover;

import meerkat.protobuf.Crypto;

/**
 * Created by Tzlil on 12/30/2015.
 */
public class ProofOrganizer {

    private final Crypto.RerandomizableEncryptedMessage e1;
    private final Crypto.RerandomizableEncryptedMessage e2;
    private final Crypto.RerandomizableEncryptedMessage e1New;
    private final Crypto.RerandomizableEncryptedMessage e2New;

    //in1, out1, in2, out1,
    //in1, out1, in1, out2
    //in2, out1, in2, out2,
    //in1, out2, in2, out2
    public ProofOrganizer(Crypto.RerandomizableEncryptedMessage e1,Crypto.RerandomizableEncryptedMessage e2
            ,Crypto.RerandomizableEncryptedMessage e1New,Crypto.RerandomizableEncryptedMessage e2New)
    {
        this.e1 = e1;
        this.e2 = e2;
        this.e1New = e1New;
        this.e2New = e2New;

    }

    public enum OrProofOrder{
        first,second,third,fourth
    }

    public Crypto.RerandomizableEncryptedMessage getE1(OrProofOrder orProofOrder)
    {
        switch (orProofOrder){
            case third:
                return e2;
            default:
                return e1;
        }

    }

    public Crypto.RerandomizableEncryptedMessage getE1New(OrProofOrder orProofOrder)
    {
        switch (orProofOrder){
            case fourth:
                return e2New;
            default:
                return e1New;
        }

    }

    public Crypto.RerandomizableEncryptedMessage getE2(OrProofOrder orProofOrder)
    {
        switch (orProofOrder){
            case second:
                return e1;
            default:
                return e2;
        }

    }

    public Crypto.RerandomizableEncryptedMessage getE2New(OrProofOrder orProofOrder)
    {
        switch (orProofOrder){
            case first:
                return e1New;
            default:
                return e2New;
        }

    }
}
